Bug 283371 - Make pulseaudio aware of ALSA mixing by default
Make pulseaudio aware of ALSA mixing by default
Product: Fedora
Classification: Fedora
Component: pulseaudio (Show other bugs)
x86_64 Linux
medium Severity low
: ---
: ---
Assigned To: Lennart Poettering
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-09-07 21:48 EDT by Valdis Kletnieks
Modified: 2007-11-30 17:12 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-09-23 20:26:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Valdis Kletnieks 2007-09-07 21:48:14 EDT
Description of problem:
If another program is using the ALSA interface, and something tries to emit a
sound via the pulseaudio 'esd' drop-in, it throws messages like this:

E: module-alsa-sink.c: Error opening PCM device hw:0: Device or resource busy

Eventually, something overflows, and we start seeing this instead:

W: sink-input.c: Failed to create sink input: too many inputs per sink.

Version-Release number of selected component (if applicable):

How reproducible:
Launch an xmms that's using the ALSA output plugin, and then try to output sound
via pulseaudio.

Steps to Reproduce:
Actual results:

Expected results:

Additional info:
This worked just fine under esound, so it's a pretty big regression.
Comment 1 Lennart Poettering 2007-09-12 12:57:25 EDT
PulseAudio is not intended to be run through dmix. If alsa-plugins-pulse is
installed ALSA output goes through PA properly which is the way it should be. On
new installations this package is installed by default. I am not sure how we
could make sure that this package is installed on upgrades too.

Comment 2 Valdis Kletnieks 2007-09-12 13:44:42 EDT
Umm, stick a 'Requires: alsa-plugins-pulse' in the .spec?
Comment 3 Valdis Kletnieks 2007-09-12 13:53:15 EDT
Boo, hiss. That won't be sufficient, I just found/read
Comment 4 Valdis Kletnieks 2007-09-14 10:38:32 EDT
xmms's libALSA.so, if pointed at 'pulse' as the device, throws *lots* of
underruns (we're talking several a second).  It makes it *totally* unlistenable.

That's even *with* 'chrt -r 5 /usr/bin/pulseaudio'.

Oh, and having to start *every* program with 'pulse' as recommended in
README-pulse is a Bad Idea - you miss one program and *everything* using Pulse
wedges up and produces no sound.

This is not ready for prime time, by a long shot.
Comment 5 John Ellson 2007-09-15 17:23:06 EDT
Is this what broke nearly all my sound about two weeks ago???   (All except
tvtime for some reason)    See: BZ#281711

I agree with the previous comment.   Anything that causes a regression like this
is not ready for prime time.
Comment 6 Lennart Poettering 2007-09-23 20:26:55 EDT
More recent versions of the ALSA plugin install themselves as "default" in ALSA now.

The ALSA plugin in 1.0.14-3 should improve compatibility with the apps currently
getting underruns when using it.

Note You need to log in before you can comment on or make changes to this bug.